// CGI JSDB Library
// All rights reserved, Jean-Marc QUERE 2008
// released under the  GNU General Public License v3
// quere.jmarc@free.fr
//
function CGI(hdr) {
	this.form=new Record();
	this.data={};
	this.ismd=false;
	this.form.read(system.getenv('HTTP_COOKIE'),'; ')
	if (system.getenv('REQUEST_METHOD')=='GET') {
		this.form.read(system.getenv('QUERY_STRING'),'&');
		this.form.set('&','GET');
	}
	else if (system.getenv('REQUEST_METHOD')=='POST') {
		this.form.read(system.stdin.read(system.getenv('CONTENT_LENGTH')),'&');
		this.form.set('&','POST');
	}
	this.form.set('%',this.form.get('%') || '');
	if (this.form.get('%')!='') {
		var file='CGI/'+this.form.get('%');
		if (system.exists(file)) {
			try {
				this.data=eval('('+new Stream(file).readText()+')');
			}
			catch (err) { 
				this.form('%')='';
			}
		}
	}
	for (var idx=0;idx<this.form.length;idx++) {
		this.form.set(this.form.name(idx),unescape(this.form.value(idx)));
	}
	if (this.form.get('%')=='') {
		this.form.set('%',this.UID());
		print('Set-Cookie: %='+this.form.get('%')+'\n');
	}
	print(hdr || 'Content-type: text/html\n\n');
}
CGI.prototype.save=function() {
	if (this.ismd) {
		try {
			new Stream('CGI/'+this.form.get('%'),'w').write(this.data.toSource());
		}
		catch (err) { }
	}
}
CGI.prototype.HX2=function(dec) {
	var res=dec.toString(16);
	return res.length==2 ? res : '0'+res;
}
CGI.prototype.UID=function() {
	var dte=new Date();
	return this.HX2(dte.getMonth())+this.HX2(dte.getDate())+this.HX2(dte.getHours())+
		this.HX2(dte.getMinutes())+this.HX2(Math.floor(Math.random()*256));
}
CGI.prototype.get=function(idx) {
	return this.form.get(idx);
}
CGI.prototype.set=function(idx,val) {
	this.form.set(idx,val);
}
CGI.prototype._get=function(idx) {
	return this.data[idx];
}
CGI.prototype._set=function(idx,val) {
	this.data[idx]=val;
	this.ismd=true;
}
CGI.prototype.write=function(nme) {
	var res='';
	try {
		res=new Stream();
		res.format(new Stream(nme).readText(),this.form,'%');
	}
	catch (err) { }
	print(res);
}
